/* $Id: io.c,v 1.4 2000/11/12 13:29:09 malekith Exp $ */

#include "class.h"
#include "binfmt.h"
#include <stdlib.h>
#include <string.h>

extern struct dbuf *code;
extern struct dbuf *class_xrefs;
extern struct class_def *class_head;

static struct dbuf *make_class_list()
{
	struct dbuf *classes;
	struct class_def *cptr;
	int len;
	
	classes = db_new();
	db_alloc(classes, 4);
	
	for (cptr = class_head, len = 0; cptr; cptr = cptr->lnext, len++) {
		db_add(classes, cptr->name, strlen(cptr->name) + 1);
		assert(cptr->id == len);
	}
	*(u32*)db_data(classes) = len;

	return classes;
}

static struct dbuf *make_func_list()
{
	struct func_def *f;
	struct dbuf *db;
	struct {
		u32 class_id, func_id;
		u32 offset;
	} it;
	
	db = db_new();
	
	for (f = func_head; f; f = f->next) {
		it.class_id = f->parent->id;
		it.func_id = f->id;
		it.offset = f->block;
		db_add(db, &it, sizeof(it));
	}

	return db;
}

static struct dbuf *make_funcs_xrefs()
{
	struct dbuf *classes;
	struct class_def *cptr;
	int len;
	
	classes = db_new();
	db_alloc(classes, 4);
	
	for (cptr = class_head, len = 0; cptr; cptr = cptr->lnext, len++) {
		*(u32*)db_alloc(classes, sizeof(u32)) = cptr->funcsize;
		db_add(classes, cptr->funcs_xrefs, cptr->funcsize * sizeof(u32));
		assert(cptr->id == len);
	}
	*(u32*)db_data(classes) = len;

	return classes;

}

extern char *in_file;

int write_out()
{
	struct kbin_file *out;
	char *fn;
	int len;
	byte *c;

	fn = (char*)malloc((len = strlen(in_file)) + 5);
	strcpy(fn, in_file);
	if (fn[len - 2] == '.' && fn[len - 1] == 'k')
		fn[len - 2] = 0;
	strcat(fn, ".ok");

	out = kbin_open(fn, 0, 0);
	
	if (out == 0)
		return -1;

#define db_dump(db, tag)				\
	c = db_finish(db, &len);			\
	kbin_add_tag(out, kbin_tag_ ## tag , len, c);	\
	free(c)

	db_dump(class_xrefs, ok_class_xrefs);
	db_dump(make_func_list(), ok_funcs);
	db_dump(make_funcs_xrefs(), ok_funcs_xrefs);
	db_dump(code, code);
	db_dump(make_class_list(), ok_classes);
	
	/* kbin_add_tag(out, kbin_tag_comment, 14, "Powered by VI\0"); */

	kbin_fini(out);

	return 0;
}

