
/* $Id: newdel.c,v 1.1 2000/11/15 01:42:18 malekith Exp $ */

#include "compiler.h"

/* expr.c */
void compile_exp(CTX *ctx, struct token *t, struct var_type *type);

void compile_new(CTX *ctx, struct token *t, struct var_type *type)
{
	struct class_def *c;
	
	assert(t->sel == sel_id);
	c = ph_find(class_hash, t->v_string);
	if (c == 0) {
		oops(t, "class `%s' undefinied", t->v_string);
		croak(ctx);
	}

	if (type) {
		type->id = sel_ptr;
		type->ptr = c;
	}

	emit(ctx,
		op_new, c,
		0
	);
}

void compile_delete(CTX *ctx, struct token *t, struct var_type *type)
{
	struct var_type x;
	
	compile_exp(ctx, t, &x);
	if (x.id != sel_ptr) {
		oops(t, "non-ptr expression on as delete argument");
		croak(ctx);
	}
	emit(ctx,
		op_mov_dA,
		op_clr_d,
		op_inc_d,
		op_jsr,
		0
	);

	if (type) {
		type->id = sel_void;
		type->ptr = 0;
	}
}
